#
# efficient pattern filling
#


from  mem.memslice import memslice
from  mem.tools import memcopy

def fill(buffer, pattern, start=0, stop=None):
    """fill the buffer by duplicating pattern."""
    if stop is not None:
        buffer = memslice(buffer, start, stop)
    else:
        buffer = memslice(buffer, start)
    start = 0
    while 1:
        try:
            memcopy(buffer, pattern, start)
        except IndexError:
            pattern = memslice(pattern, 0, len(buffer)-start)
            memcopy(buffer, pattern, start)
            break
        start += len(pattern)
        pattern = memslice(buffer, 0, start)

if __name__=='__main__':
    #
    # a few tests
    #

    from  mem.chunk import chunk
    a= chunk("."*4)
    fill(a, "xy",1)
    assert a == chunk(".xyx")

    a= chunk("."*6)
    fill(a, "xyxyxy",1,-1)
    assert a == chunk(".xyxy.")

