"""
How to use the StrArray module on a mmaped file 
mmap work both on Unixes and Window and allow to provide
a buffer interface to disk-files.

This can be used to create very huge arrays.
""""

#  let's create the mmap support
from tempfile import TemporaryFile
F = TemporaryFile()
SIZE = 400 #assume sizeof(int)=4
F.write("\0"*SIZE)  
F.seek(0)

# and now the real sample
from mem.StrArray import StrArray
import mmap
A = StrArray('i', mmap.mmap(F.fileno(), SIZE))
for i in range(100):
    A[i] = 2*i
for x in A:
    print x,
print
print '-'*50
del A

# finally let's check that the data are written on the file
B = StrArray('i', F.read())
for x in B:
    print x,
print

