from distutils.core import setup, Extension


info = """
The Version 0.3 add four Functions for computing diffs into the
tools modules. It also remove support for Python 2.2.


The mem package is a set of extension modules which alow to work
on objects memory from Python code. The package contains:

  - an object which allow to manage mallocated chunks of memory as a
    mutable sequence of bytes.

  - a set of functions which work on any objects which define the buffer
    API: memcopy, index, memlen, memcmp ...

  - a reimplementation of the buffer() built-in object which should
    correct it's most annoying problems.

It contains also some pure Python modules:

  - an adaptater which provide the file interface to any object which
    define the buffer API.

  - an other adaptater for the array interface.
"""


setup(name="mem", version = "0.3",
      description="memory manipulation",
      author="Sebastien Keim",
      author_email="s.keim@laposte.net",
      url = "http://www.zope.org/Members/s.keim/wiki/MemPackage/FrontPage",
      packages = ["mem"],
      license = "BSD",
      long_description = info,
      keywords = "buffer memory",

      
      ext_modules = [
          Extension("mem.memslice", ["mem/memslicemodule.c"]),
          Extension("mem.chunk", ["mem/chunkmodule.c"]),
          Extension("mem.tools", ["mem/memtoolsmodule.c"]),
      ]
     )
